registerOutputEvent("FxDTSBrick", "playPitchedSound", "dataBlock Sound" TAB "float 0.2 2 0.01 1");

function FxDTSBrick::playPitchedSound(%this, %sound, %pitch) {
	if (!isObject(%this) || !isObject(%sound) || %sound.getClassName() !$= "AudioProfile") {
		return;
  }

	if (%sound.description.isLooping) {
		return;
  }

  if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
    for (%i = 0; %i < clientGroup.getCount(); %i++) {
      %client = clientGroup.getObject(%i);

      %client.playPitched3D(%sound, %this.getTransform(), %pitch);
    }
  } else {
    %oldTimescale = getTimescale();

    if (getBuildNumber() <= 1511) {
      commandToAll('timeScale', %pitch);

      serverPlay3D(%sound, %this.getPosition());

      commandToAll('timeScale', %oldTimescale);
    } else {
      setTimescale(%pitch);

      serverPlay3D(%sound, %this.getPosition());

      setTimescale(%oldTimescale);
    }
  }
}

if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
  registerOutputEvent("FxDTSBrick", "playPitchedSound2", "dataBlock Sound" TAB "string 5 44");
}

function FxDTSBrick::playPitchedSound2(%this, %sound, %pitch) {
  %this.playPitchedSound(%sound, %pitch);
}

registerOutputEvent("GameConnection", "playPitchedSound", "dataBlock Sound" TAB "float 0.2 2 0.01 1");

function GameConnection::playPitchedSound(%this, %sound, %pitch) {
	if (!isObject(%this) || !isObject(%sound) || %sound.getClassName() !$= "AudioProfile") {
		return;
  }

	if (%sound.description.isLooping) {
		return;
  }

  if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
    %this.playPitched2D(%sound, %pitch);
  } else {
    %oldTimescale = getTimescale();

    if (getBuildNumber() <= 1511) {
      commandToAll('timeScale', %pitch);

      %this.play2D(%sound);

      commandToAll('timeScale', %oldTimescale);
    } else {
      setTimescale(%pitch);

      %this.play2D(%sound);

      setTimescale(%oldTimescale);
    }
  }
}

if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
  registerOutputEvent("GameConnection", "playPitchedSound2", "dataBlock Sound" TAB "string 5 44");
}

function GameConnection::playPitchedSound2(%this, %sound, %pitch) {
  %this.playPitchedSound(%sound, %pitch);
}

registerOutputEvent("FxDTSBrick", "playRandomPitchedSound", "dataBlock Sound" TAB "float 0.2 2 0.1 1" TAB "float 0.2 2 0.1 1" TAB "bool");

function FxDTSBrick::playRandomPitchedSound(%this, %sound, %min, %max, %precision) {
	if (!isObject(%this) || !isObject(%sound) || %sound.getClassName() !$= "AudioProfile") {
		return;
  }

	if (%sound.description.isLooping) {
		return;
  }

  if (%precision) {
    if (%precision == 1) {
      %pitch = getRandom(%min * 100, %max * 100) / 100;
    } else {
      if (%precision == 8) %precision = 1;
      if (%precision == 16) %precision = 10;
      if (%precision == 32) %precision = 100;

      %pitch = getRandom(%min * %precision, %max * %precision) / %precision;
    }
  } else {
    %pitch = getRandom(%min * 10, %max * 10) / 10;
  }

  if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
    %pitch = mClampF(%pitch, 0.1, 22);

    for (%i = 0; %i < clientGroup.getCount(); %i++) {
      %client = clientGroup.getObject(%i);

      %client.playPitched3D(%sound, %this.getTransform(), %pitch);
    }
  } else {
    %oldTimescale = getTimescale();

    if (getBuildNumber() <= 1511) {
      commandToAll('timeScale', %pitch);

      serverPlay3D(%sound, %this.getPosition());

      commandToAll('timeScale', %oldTimescale);
    } else {
      setTimescale(%pitch);

      serverPlay3D(%sound, %this.getPosition());

      setTimescale(%oldTimescale);
    }
  }
}

if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
  registerOutputEvent("FxDTSBrick", "playRandomPitchedSound2", "dataBlock Sound" TAB "string 5 44" TAB "string 5 44" TAB "list 1x 8 10x 16 100x 32");
}

function FxDTSBrick::playRandomPitchedSound2(%this, %sound, %min, %max, %precision) {
  %this.playRandomPitchedSound(%sound, %min, %max, %precision);
}

registerOutputEvent("GameConnection", "playRandomPitchedSound", "dataBlock Sound" TAB "float 0.2 2 0.1 1" TAB "float 0.2 2 0.1 1" TAB "bool");

function GameConnection::playRandomPitchedSound(%this, %sound, %min, %max, %precision) {
	if (!isObject(%this) || !isObject(%sound) || %sound.getClassName() !$= "AudioProfile") {
		return;
  }

	if (%sound.description.isLooping) {
		return;
  }

  if (%precision) {
    if (%precision == 1) {
      %pitch = getRandom(%min * 100, %max * 100) / 100;
    } else {
      if (%precision == 8) %precision = 1;
      if (%precision == 16) %precision = 10;
      if (%precision == 32) %precision = 100;

      %pitch = getRandom(%min * %precision, %max * %precision) / %precision;
    }
  } else {
    %pitch = getRandom(%min * 10, %max * 10) / 10;
  }

  if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
    %pitch = mClampF(%pitch, 0.1, 22);

    %this.playPitched2D(%sound, %pitch);
  } else {
    %oldTimescale = getTimescale();

    if (getBuildNumber() <= 1511) {
      commandToAll('timeScale', %pitch);

      %this.play2D(%sound);

      commandToAll('timeScale', %oldTimescale);
    } else {
      setTimescale(%pitch);

      %this.play2D(%sound);

      setTimescale(%oldTimescale);
    }
  }
}

if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
  registerOutputEvent("GameConnection", "playRandomPitchedSound2", "dataBlock Sound" TAB "string 5 44" TAB "string 5 44" TAB "list 1x 8 10x 16 100x 32");
}

function GameConnection::playRandomPitchedSound2(%this, %sound, %min, %max, %precision) {
  %this.playRandomPitchedSound(%sound, %min, %max, %precision);
}

if (isPackage(playPitchedSound)) {
  deactivatePackage(playPitchedSound);
}

package playPitchedSound {

  function serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4) {
    parent::serverCmdAddEvent(%client, %enabled, %inputEventIdx, %delay, %targetIdx, %NTNameIdx, %outputEventIdx, %par1, %par2, %par3, %par4);

    if (isObject(%brick = %client.wrenchBrick)) {
      for (%i = 0; %i < %brick.numEvents; %i++) {
        %eventOutput = %brick.eventOutput[%i];

        if (%eventOutput $= "playPitchedSound2" || %eventOutput $= "playRandomPitchedSound2") {
          //%sound = %brick.eventOutputParameter[%i, 1];
          %pitch = strTrim(%brick.eventOutputParameter[%i, 2]);

          if (getSubStr(%pitch, 0, 1) $= ".") {
            %pitch = "0" @ %pitch;
          }

          if (%pitch <= 999999 && %pitch >= -999999) {
            if (%pitch !$= %pitch * 1) {
              %pitch = 1;
            }
          }

          %pitch = mClampF(%pitch, 0.1, 22);

          %brick.eventOutputParameter[%i, 2] = %pitch;
        }

        if (%eventOutput $= "playRandomPitchedSound2") {
          %pitch = strTrim(%brick.eventOutputParameter[%i, 3]);

          if (getSubStr(%pitch, 0, 1) $= ".") {
            %pitch = "0" @ %pitch;
          }

          if (%pitch <= 999999 && %pitch >= -999999) {
            if (%pitch !$= %pitch * 1) {
              %pitch = 1;
            }
          }

          %pitch = mClampF(%pitch, 0.1, 22);

          %brick.eventOutputParameter[%i, 3] = %pitch;
        }
      }
    }
  }

};

if (isFunction("isBlocklandRebuilt") && isBlocklandRebuilt()) {
  activatePackage(playPitchedSound);
}
